Code

git-am -i: report rewritten title
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--keep] [--utf8 | --no-utf8]
6   [--3way] [--interactive] [--binary]
7   [--whitespace=<option>] [-C<n>] [-p<n>]
8   <mbox>|<Maildir>...
9   or, when resuming [--skip | --resolved]'
10 . git-sh-setup
11 set_reflog_action am
12 require_work_tree
14 git var GIT_COMMITTER_IDENT >/dev/null || exit
16 stop_here () {
17     echo "$1" >"$dotest/next"
18     exit 1
19 }
21 stop_here_user_resolve () {
22     if [ -n "$resolvemsg" ]; then
23             printf '%s\n' "$resolvemsg"
24             stop_here $1
25     fi
26     cmdline=$(basename $0)
27     if test '' != "$interactive"
28     then
29         cmdline="$cmdline -i"
30     fi
31     if test '' != "$threeway"
32     then
33         cmdline="$cmdline -3"
34     fi
35     if test '.dotest' != "$dotest"
36     then
37         cmdline="$cmdline -d=$dotest"
38     fi
39     echo "When you have resolved this problem run \"$cmdline --resolved\"."
40     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
42     stop_here $1
43 }
45 go_next () {
46         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
47                 "$dotest/patch" "$dotest/info"
48         echo "$next" >"$dotest/next"
49         this=$next
50 }
52 cannot_fallback () {
53         echo "$1"
54         echo "Cannot fall back to three-way merge."
55         exit 1
56 }
58 fall_back_3way () {
59     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
61     rm -fr "$dotest"/patch-merge-*
62     mkdir "$dotest/patch-merge-tmp-dir"
64     # First see if the patch records the index info that we can use.
65     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
66         "$dotest/patch" &&
67     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68     git write-tree >"$dotest/patch-merge-base+" ||
69     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
71     echo Using index info to reconstruct a base tree...
72     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73         git apply $binary --cached <"$dotest/patch"
74     then
75         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77     else
78         cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
80     fi
82     test -f "$dotest/patch-merge-index" &&
83     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
84     orig_tree=$(cat "$dotest/patch-merge-base") &&
85     rm -fr "$dotest"/patch-merge-* || exit 1
87     echo Falling back to patching base and 3-way merge...
89     # This is not so wrong.  Depending on which base we picked,
90     # orig_tree may be wildly different from ours, but his_tree
91     # has the same set of wildly different changes in parts the
92     # patch did not touch, so recursive ends up canceling them,
93     # saying that we reverted all those changes.
95     eval GITHEAD_$his_tree='"$SUBJECT"'
96     export GITHEAD_$his_tree
97     git-merge-recursive $orig_tree -- HEAD $his_tree || {
98             git rerere
99             echo Failed to merge in the changes.
100             exit 1
101     }
102     unset GITHEAD_$his_tree
105 reread_subject () {
106         git stripspace <"$1" | sed -e 1q
109 prec=4
110 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
111 resolvemsg= resume=
112 git_apply_opt=
114 while test $# != 0
115 do
116         case "$1" in
117         -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
118         dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
119         -d|--d|--do|--dot|--dote|--dotes|--dotest)
120         case "$#" in 1) usage ;; esac; shift
121         dotest="$1"; shift;;
123         -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
124         --interacti|--interactiv|--interactive)
125         interactive=t; shift ;;
127         -b|--b|--bi|--bin|--bina|--binar|--binary)
128         binary=t; shift ;;
130         -3|--3|--3w|--3wa|--3way)
131         threeway=t; shift ;;
132         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
133         sign=t; shift ;;
134         -u|--u|--ut|--utf|--utf8)
135         utf8=t; shift ;; # this is now default
136         --no-u|--no-ut|--no-utf|--no-utf8)
137         utf8=; shift ;;
138         -k|--k|--ke|--kee|--keep)
139         keep=t; shift ;;
141         -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
142         resolved=t; shift ;;
144         --sk|--ski|--skip)
145         skip=t; shift ;;
147         --whitespace=*|-C*|-p*)
148         git_apply_opt="$git_apply_opt $1"; shift ;;
150         --resolvemsg=*)
151         resolvemsg=${1#--resolvemsg=}; shift ;;
153         --)
154         shift; break ;;
155         -*)
156         usage ;;
157         *)
158         break ;;
159         esac
160 done
162 # If the dotest directory exists, but we have finished applying all the
163 # patches in them, clear it out.
164 if test -d "$dotest" &&
165    last=$(cat "$dotest/last") &&
166    next=$(cat "$dotest/next") &&
167    test $# != 0 &&
168    test "$next" -gt "$last"
169 then
170    rm -fr "$dotest"
171 fi
173 if test -d "$dotest"
174 then
175         case "$#,$skip$resolved" in
176         0,*t*)
177                 # Explicit resume command and we do not have file, so
178                 # we are happy.
179                 : ;;
180         0,)
181                 # No file input but without resume parameters; catch
182                 # user error to feed us a patch from standard input
183                 # when there is already .dotest.  This is somewhat
184                 # unreliable -- stdin could be /dev/null for example
185                 # and the caller did not intend to feed us a patch but
186                 # wanted to continue unattended.
187                 tty -s
188                 ;;
189         *)
190                 false
191                 ;;
192         esac ||
193         die "previous dotest directory $dotest still exists but mbox given."
194         resume=yes
195 else
196         # Make sure we are not given --skip nor --resolved
197         test ",$skip,$resolved," = ,,, ||
198                 die "Resolve operation not in progress, we are not resuming."
200         # Start afresh.
201         mkdir -p "$dotest" || exit
203         git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
204                 rm -fr "$dotest"
205                 exit 1
206         }
208         # -b, -s, -u, -k and --whitespace flags are kept for the
209         # resuming session after a patch failure.
210         # -3 and -i can and must be given when resuming.
211         echo "$binary" >"$dotest/binary"
212         echo " $ws" >"$dotest/whitespace"
213         echo "$sign" >"$dotest/sign"
214         echo "$utf8" >"$dotest/utf8"
215         echo "$keep" >"$dotest/keep"
216         echo 1 >"$dotest/next"
217 fi
219 case "$resolved" in
220 '')
221         files=$(git diff-index --cached --name-only HEAD --) || exit
222         if [ "$files" ]; then
223            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
224            exit 1
225         fi
226 esac
228 if test "$(cat "$dotest/binary")" = t
229 then
230         binary=--allow-binary-replacement
231 fi
232 if test "$(cat "$dotest/utf8")" = t
233 then
234         utf8=-u
235 else
236         utf8=-n
237 fi
238 if test "$(cat "$dotest/keep")" = t
239 then
240         keep=-k
241 fi
242 ws=`cat "$dotest/whitespace"`
243 if test "$(cat "$dotest/sign")" = t
244 then
245         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
246                         s/>.*/>/
247                         s/^/Signed-off-by: /'
248                 `
249 else
250         SIGNOFF=
251 fi
253 last=`cat "$dotest/last"`
254 this=`cat "$dotest/next"`
255 if test "$skip" = t
256 then
257         git rerere clear
258         this=`expr "$this" + 1`
259         resume=
260 fi
262 if test "$this" -gt "$last"
263 then
264         echo Nothing to do.
265         rm -fr "$dotest"
266         exit
267 fi
269 while test "$this" -le "$last"
270 do
271         msgnum=`printf "%0${prec}d" $this`
272         next=`expr "$this" + 1`
273         test -f "$dotest/$msgnum" || {
274                 resume=
275                 go_next
276                 continue
277         }
279         # If we are not resuming, parse and extract the patch information
280         # into separate files:
281         #  - info records the authorship and title
282         #  - msg is the rest of commit log message
283         #  - patch is the patch body.
284         #
285         # When we are resuming, these files are either already prepared
286         # by the user, or the user can tell us to do so by --resolved flag.
287         case "$resume" in
288         '')
289                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
290                         <"$dotest/$msgnum" >"$dotest/info" ||
291                         stop_here $this
293                 # skip pine's internal folder data
294                 grep '^Author: Mail System Internal Data$' \
295                         <"$dotest"/info >/dev/null &&
296                         go_next && continue
298                 test -s $dotest/patch || {
299                         echo "Patch is empty.  Was it split wrong?"
300                         stop_here $this
301                 }
302                 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
303                 ;;
304         esac
306         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
307         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
308         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
310         if test -z "$GIT_AUTHOR_EMAIL"
311         then
312                 echo "Patch does not have a valid e-mail address."
313                 stop_here $this
314         fi
316         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
318         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
319         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
321         case "$resume" in
322         '')
323             if test '' != "$SIGNOFF"
324             then
325                 LAST_SIGNED_OFF_BY=`
326                     sed -ne '/^Signed-off-by: /p' \
327                     "$dotest/msg-clean" |
328                     tail -n 1
329                 `
330                 ADD_SIGNOFF=`
331                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
332                     test '' = "$LAST_SIGNED_OFF_BY" && echo
333                     echo "$SIGNOFF"
334                 }`
335             else
336                 ADD_SIGNOFF=
337             fi
338             {
339                 printf '%s\n' "$SUBJECT"
340                 if test -s "$dotest/msg-clean"
341                 then
342                         echo
343                         cat "$dotest/msg-clean"
344                 fi
345                 if test '' != "$ADD_SIGNOFF"
346                 then
347                         echo "$ADD_SIGNOFF"
348                 fi
349             } >"$dotest/final-commit"
350             ;;
351         *)
352                 case "$resolved$interactive" in
353                 tt)
354                         # This is used only for interactive view option.
355                         git diff-index -p --cached HEAD -- >"$dotest/patch"
356                         ;;
357                 esac
358         esac
360         resume=
361         if test "$interactive" = t
362         then
363             test -t 0 ||
364             die "cannot be interactive without stdin connected to a terminal."
365             action=again
366             while test "$action" = again
367             do
368                 echo "Commit Body is:"
369                 echo "--------------------------"
370                 cat "$dotest/final-commit"
371                 echo "--------------------------"
372                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
373                 read reply
374                 case "$reply" in
375                 [yY]*) action=yes ;;
376                 [aA]*) action=yes interactive= ;;
377                 [nN]*) action=skip ;;
378                 [eE]*) git_editor "$dotest/final-commit"
379                        SUBJECT=$(reread_subject "$dotest/final-commit")
380                        action=again ;;
381                 [vV]*) action=again
382                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
383                 *)     action=again ;;
384                 esac
385             done
386         else
387             action=yes
388         fi
390         if test $action = skip
391         then
392                 go_next
393                 continue
394         fi
396         if test -x "$GIT_DIR"/hooks/applypatch-msg
397         then
398                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
399                 stop_here $this
400         fi
402         echo
403         printf 'Applying %s\n' "$SUBJECT"
404         echo
406         case "$resolved" in
407         '')
408                 git apply $git_apply_opt $binary --index "$dotest/patch"
409                 apply_status=$?
410                 ;;
411         t)
412                 # Resolved means the user did all the hard work, and
413                 # we do not have to do any patch application.  Just
414                 # trust what the user has in the index file and the
415                 # working tree.
416                 resolved=
417                 git diff-index --quiet --cached HEAD -- && {
418                         echo "No changes - did you forget to use 'git add'?"
419                         stop_here_user_resolve $this
420                 }
421                 unmerged=$(git ls-files -u)
422                 if test -n "$unmerged"
423                 then
424                         echo "You still have unmerged paths in your index"
425                         echo "did you forget to use 'git add'?"
426                         stop_here_user_resolve $this
427                 fi
428                 apply_status=0
429                 git rerere
430                 ;;
431         esac
433         if test $apply_status = 1 && test "$threeway" = t
434         then
435                 if (fall_back_3way)
436                 then
437                     # Applying the patch to an earlier tree and merging the
438                     # result may have produced the same tree as ours.
439                     git diff-index --quiet --cached HEAD -- && {
440                         echo No changes -- Patch already applied.
441                         go_next
442                         continue
443                     }
444                     # clear apply_status -- we have successfully merged.
445                     apply_status=0
446                 fi
447         fi
448         if test $apply_status != 0
449         then
450                 echo Patch failed at $msgnum.
451                 stop_here_user_resolve $this
452         fi
454         if test -x "$GIT_DIR"/hooks/pre-applypatch
455         then
456                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
457         fi
459         tree=$(git write-tree) &&
460         echo Wrote tree $tree &&
461         parent=$(git rev-parse --verify HEAD) &&
462         commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
463         echo Committed: $commit &&
464         git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
465         stop_here $this
467         if test -x "$GIT_DIR"/hooks/post-applypatch
468         then
469                 "$GIT_DIR"/hooks/post-applypatch
470         fi
472         go_next
473 done
475 rm -fr "$dotest"